//+------------------------------------------------------------------+
//|                                     CLOSE PRICE CROSSES OVER EMA |
//|                                                     Duarte Silva |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Duarte Silva"
#property strict
#property link "http://forex-indicators.net/bill-williams/fractals"
#property link "http://blackglasses.me/2014/05/11/fractals-and-forex-a-new-perspective/"
#property link "http://www.investopedia.com/articles/trading/06/fractals.asp"
#property link "https://www.mql5.com/en/articles/1201"
#property link "https://www.mql5.com/en/code/8718"
#property link "https://www.mql5.com/en/articles/1429"


#define FractalStudy "EA for Fractal study"

//+------------------------------------------------------------------+
//| Indicadores                                                      |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//--- Buffer dos indicadores
double Fractal_Upper_Buffer[];
double Fractal_Lower_Buffer[];

//+------------------------------------------------------------------+
//| Declarao e inicializao de Variveis Externas (Optimizao)   |
//+------------------------------------------------------------------+
extern int EMA_sPeriod = 8;
extern int EMA_lPeriod = 21;
extern int EMA_Method=1;

//+------------------------------------------------------------------+
//| Declarao das Variveis Globais da funo                       |
//+------------------------------------------------------------------+
bool LongTrend,ShortTrend,LongOnMarket,ShortOnMarket,FractalUpperFound,FractalLowerFound;
int ticket=0,PositionIndex=0,NumSellOrders=0,NumBuyOrders=0;
double OrderPrice=0.0;
double Lots;
//double ShortEMA, ShortEMA_P, LongEMA, LongEMA_P;
double Fractal_Upper,Fractal_Lower;
datetime Lastbar,Curbar; //Open time of last bar   // Open time of current bar
int iMagicNum=19820506;
int Previous_Bars=0,Unchecked_Bars=0, Control_Bars = 0;
string LastObjectName, DeleteObjectName;
int ObjTotal,FractalUpperCounter=0,FractalLowerCounter=0,UpperBarIndex=0,LowerBarIndex=0;
//+------------------------------------------------------------------+
//| Inicializao do Expert Adviser                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- Data/hora de abertura da ltima barra
   Lastbar=Time[1];

   Previous_Bars=Bars;////////////////////////////////////////////Ateno ao nmero de barras do histrico)
   Unchecked_Bars=0;
   Print("*** INICIALIZAO ***");
   Print("N de barras a ler: ",Previous_Bars);

//--- Gerar um  nmero nico para cada par
   if(Symbol()=="EURUSD") iMagicNum=iMagicNum+1+Period();
   else if(Symbol() == "USDJPY") iMagicNum= iMagicNum + 2 + Period();
   else if(Symbol() == "GBPUSD") iMagicNum= iMagicNum + 3 + Period();
   else Print("Nenhum Simbolo Seleccionado");

   Print("Simbolo: ",Symbol(),"Nmero Mgico: ",iMagicNum);

//---- indicator buffers mapping
   SetIndexBuffer(0,Fractal_Upper_Buffer);
   SetIndexBuffer(1,Fractal_Lower_Buffer);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,119);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(0,119);
//---- Name for Datawindow
   SetIndexLabel(0,"Fractal Up");
   SetIndexLabel(0,"Fractal Down");
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {

//--- Variveis locais e estticas
   if(NewBarDetection()) //Aes a realizar no incio de cada vela japonesa
     {
      if((FractalLowerFound) && (Bars>=LowerBarIndex + 2))
        {
            Control_Bars = Bars - LowerBarIndex;
            if(Low[Control_Bars] < Low[Control_Bars+2] && Low[Control_Bars] < Low[Control_Bars+1] && Low[Control_Bars] < Low[Control_Bars-1] && Low[Control_Bars] < Low[Control_Bars-2])
              {
               FractalLowerCounter = FractalLowerCounter - 1;
               FractalLowerFound = false;
               Print("Contador de Lower Fractals: ", FractalLowerCounter);
               Print("Lower Fractal CONFIRMADO: ",iTime(NULL,0,Control_Bars));
              }
            else
              {
               FractalLowerCounter = FractalLowerCounter - 1;
               FractalLowerFound = false;
               ObjTotal=ObjectsTotal() -2;
               DeleteObjectName = "ARROW BUY Obj: "+TimeToString(iTime(NULL,0,Control_Bars));
               DeleteObject(DeleteObjectName);
               Print("Contador de Lower Fractals: ", FractalLowerCounter, "N de Objectos", ObjTotal);
               Print("Lower Fractal FALSO -> APAGAR: ",iTime(NULL,0,Control_Bars), " -> ",DeleteObjectName);
              }
        }
      if((FractalUpperFound) && (Bars>=UpperBarIndex + 2))
        {
            Control_Bars = Bars - UpperBarIndex;
            if(High[Control_Bars] > High[Control_Bars+2] && High[Control_Bars] >= High[Control_Bars+1] && High[Control_Bars] >= High[Control_Bars-1] && High[Control_Bars] > High[Control_Bars-2])
              {
               FractalUpperCounter = FractalUpperCounter - 1;
               FractalUpperFound = false;
               Print("Contador de Upper Fractals: ", FractalUpperCounter);
               Print("Upper Fractal CONFIRMADO: ",iTime(NULL,0,Control_Bars));
              }
             else
               {
               FractalUpperCounter = FractalUpperCounter - 1;
               FractalUpperFound = false;
               ObjTotal=ObjectsTotal() -2;
               DeleteObjectName = "ARROW SELL Obj: "+TimeToString(iTime(NULL,0,Control_Bars));
               DeleteObject(DeleteObjectName);
               Print("Contador de Upper Fractals: ", FractalUpperCounter, "N de Objectos", ObjTotal);
               Print("Upper Fractal FALSO -> APAGAR: ",iTime(NULL,0,Control_Bars), " -> ",DeleteObjectName);
               }
        }
        
        
      if(Bars<0) Print("Erro na contagem de barras");
      
      Unchecked_Bars= Bars-Previous_Bars;
      Previous_Bars = Bars;
      Print("N de barras a ler: ",Unchecked_Bars," N de barras total: ",Bars);

      for(int i=1; i<Unchecked_Bars+2;i++)
        {
         Fractal_Lower=iFractals(NULL,0,MODE_LOWER,i);
         if(Fractal_Lower!=NULL)
           {
            FractalLowerCounter=FractalLowerCounter+1;
            FractalLowerFound=true;
            LowerBarIndex=Bars - i;
            Print("Lower Fractal: ",NormalizeDouble(Fractal_Lower,3)," Contador de Lower Fractals: ",FractalLowerCounter," Fractal Index: ", LowerBarIndex);
            if(!ObjectCreate("ARROW BUY Obj: "+TimeToString(Time[i],TIME_DATE|TIME_SECONDS),OBJ_ARROW_UP,0,Time[i],Low[i]))
              {
               Print("Erro impresso objecto - Lower: ",GetLastError());
              }
           }
         Fractal_Upper=iFractals(NULL,0,MODE_UPPER,i);
         if(Fractal_Upper!=NULL)
           {
            FractalUpperCounter=FractalUpperCounter+1;
            FractalUpperFound=true;
            UpperBarIndex=Bars - i;
            Print("Upper Fractal: ",NormalizeDouble(Fractal_Upper,3),"Contador de Upper Fractals: ",FractalUpperCounter," Fractal Index: ",UpperBarIndex);
            if(!ObjectCreate("ARROW SELL Obj: "+TimeToString(Time[i],TIME_DATE|TIME_SECONDS),OBJ_ARROW_DOWN,0,Time[i],High[i]+0.003))
              {
               Print("Erro impresso objecto - Upper: ",GetLastError());
              }
           }
        }
      

     }   //NewBarDetection
  }
//+------------------------------------------------------------------+
//| Funes Auxiliares                                            |
//+------------------------------------------------------------------+

//--------------------- Detecta abertura de nova barra --------------------------//
bool NewBarDetection()
  {
   Curbar=Time[0]; // Open time of current bar

   if(Lastbar!=Curbar)
     {
      Lastbar=Curbar;
      Print("Nova Barra: ", TimeToString(Time[0],TIME_DATE|TIME_SECONDS));
      //FractalUpperFound = false;
      //FractalLowerFound = false;

      NumBuyOrders=0;
      NumSellOrders=0;   //Inicializar os contadores

      for(PositionIndex=OrdersTotal()-1; PositionIndex>=0; PositionIndex--)
        {
         if(OrderSelect(PositionIndex,SELECT_BY_POS) && OrderMagicNumber()==iMagicNum && OrderSymbol()==Symbol())
           {
            if(OrderType() == OP_BUY)  NumBuyOrders++;
            if(OrderType() == OP_SELL) NumSellOrders++;
           }
        }
      //Print("Buy Orders: ",NumBuyOrders,"Sell Orders: ",NumSellOrders);

      return (true);
     }
   else return(false);

  }
  
//--------------------- Apaga Objectos --------------------------//
void DeleteObject(string sname)
   {
   for(int iObj=ObjectsTotal()-1; iObj >= 0; iObj--)
      {
       string on = ObjectName(iObj);
       if (StringFind(on,sname) == 0)
         {
         ObjectDelete(on);
         Print("OBJECTO APAGADO: ", on);
         }
       }   
   }  
//--------------------- Efetua a compra de posies longas --------------------------//
void BuyLongPosition(double lots)
  {
//ticket = OrderSend(Symbol(),OP_BUYLIMIT,lots,Ask-(CandleSizePips*0.5),3,StopLossValue,TakeProfitValue,"Compra Longos",iMagicNum,0,Blue);
   ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,0,"Compra Longos",iMagicNum,0,Blue);
   if(ticket<0)
     {
      Print("Ordem Falhada por Erro:# ",GetLastError());
     }
   else
     {
      if(OrderSelect(ticket,SELECT_BY_TICKET)==true){OrderPrice=OrderClosePrice();}
      LongOnMarket=true;
      ShortOnMarket=false;
      Print("Ordem Bem Sucedida: ticket =",ticket,"ClosePrice",OrderPrice);
     }
  }
//--------------------- Efetua a compra de posies curtas --------------------------//
void BuyShortPosition(double lots)
  {
//ticket = OrderSend(Symbol(),OP_SELLLIMIT,lots,Bid+(CandleSizePips*0.5),3,StopLossValue,TakeProfitValue,"Compra Curtos",iMagicNum,0,Red);
   ticket=OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,0,"Compra Curtos",iMagicNum,0,Red);
   if(ticket<0)
     {
      Print("Ordem Falhada por Erro:# ",GetLastError());
     }
   else
     {
      if(OrderSelect(ticket,SELECT_BY_TICKET)==true){OrderPrice=OrderClosePrice();}
      ShortOnMarket= true;
      LongOnMarket = false;
      Print("Ordem Bem Sucedida: ticket =",ticket,"ClosePrice",OrderPrice);

     }
  }
//--------------------- Fechar ordens abertas --------------------------//
bool CloseOpenOrders()
  {
   Print("N de ordens abertas:# ",OrdersTotal());

   for(PositionIndex=OrdersTotal()-1; PositionIndex>=0; PositionIndex --) //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
     {
      if(!OrderSelect(PositionIndex,SELECT_BY_POS,MODE_TRADES)) continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex

      if(!OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3))
        {
         Print("Ordem Falhada por Erro:# ",OrderTicket()," Error: ",GetLastError());  // <-- if the Order Close failed print some helpful information 
         return (false);
        }
      else
        {
         Print("Ordem fechada correctamente ");
         if(LongOnMarket==1) LongOnMarket=0;
         if(ShortOnMarket==1) ShortOnMarket=0;
         return (true);
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
